<template>
    <v-card class="elevation-3">
        <Loading :visible="isLoading" />
        <v-card-title>
            Historique des commandes
        </v-card-title>
        <v-data-table v-if="!selectedOrder" :headers="headers" :items="ordersList" :sort-by="['paymentDate']" :sort-desc="[true]" class="elevation-1"
            :loading="isLoading" loading-text="Récupération des données..." hide-default-footer>
            <template v-slot:item.isActive="{ item }">
                <v-icon :color="item.isActive ?'green': 'red'">{{item.isActive ? 'mdi-check': 'mdi-close'}}
                </v-icon>
            </template>
            <template v-slot:item.actions="{ item }">
                <v-icon @click="handleSelect(item)">
                    mdi-eye
                </v-icon>
            </template>
        </v-data-table>

        <OrderDetails v-if="selectedOrder" :orderDetails="selectedOrder" @closed="handleClose"/>
    </v-card>
</template>

<script>

import { mapActions } from 'vuex';
import {
  mapFields
} from 'vuex-map-fields';
import moment from 'moment';
import Loading from '../../components/Loading';
import OrderDetails from '../../components/user/OrderDetails';

export default {
  name: 'UserOrders',
  mixins: [],
  components:{
    Loading,
    OrderDetails
  },
  data: () => ({
    headers: [
      {
        text: 'N° de commande',
        align: 'start',
        sortable: false,
        value: 'cartReference'
      },
      { text: 'Date de commande', value: 'paymentDate', align: 'center' },
      { text: 'Prix', value: 'price'},
      { text: 'Détails',align: 'center', value: 'actions', sortable: false },
    ],
    ordersList: [],
    imageAvatar: null,
    imageUrl:'',
    selectedOrder : null
  }),
  computed: {
    ...mapFields('user', ['orders','error', 'isLoading']),
  },
  created() {
    this.getOrders();
  },
  methods: {
    parseOrdersData:function(tempOrders) {
      return tempOrders.map(value => {
        value.price = value.price + '€';
        value.paymentDate = moment(value.paymentDate).format('DD/MM/YYYY à H:mm');
        return value;
      });
    },
    selectOrder: function(refId) {
      for (const ord of  this.ordersList) {
        if (ord.cartReference === refId) {
          this.selectedOrder = ord;
          return;
        }
      }
    },
    handleSelect:function(item) {
      this.selectedOrder = item;
    },
    handleClose() {
      this.selectedOrder = null;
    },
     ...mapActions('user', ['getOrders'])
  },
  watch: {
    orders(newOrders) {
      if (newOrders && newOrders.length > 0) {
          let newOrdersCopy = newOrders.map(value => {
            return {...value}
          });
          this.ordersList = this.parseOrdersData(newOrdersCopy);
          if (this.$route.params.id) {
            this.selectOrder(this.$route.params.id);
          }
      }
    }
  }
}
</script>
